* PROGRAM:  VCODE.PRG
* FUNCTION: VALIDATE CODED FIELD (GENERIC VALIDATION UDF)
* RETURNS:  MVALID
* REQUIRES: 
* NOTE:     ASSUMPTIONS:  set udfparms to reference
*                         TBL AND TDX NAME SAME

PARAMETERS MFLD_VAL, MTBL, MFLD_TITLE, MDISP_DESC, MOPTIONAL

* MFLD_VAL     active get; unless passed in, it cannot be changed if looked up
* MTBL         data base and index for lookup; index usually same name as dbf

MGET_ROW = row()
MGET_COL = col()-len(mfld_val)

MVALID = .F.

MAREA = SELECT()
SELECT 0
USE (MTBL) INDEX (MTBL)

MCODE_FLD = FIELD(1)
MDESC_FLD = FIELD(2)

MCODE_LEN = LEN(&MCODE_FLD)

DEFINE WINDOW VCODEMSG FROM SROW()-1,00 TO SROW()-1,SCOL()-1 NONE

DO CASE

   CASE "?" $ MFLD_VAL .OR. "/" $ MFLD_VAL
      * ?, or / - pick list

      * location of browpick window is somewhat dynamic
      mbott_row = 03 + min(reccount()+3,15)
      MDESC = BROWPICK("","",MCODE_FLD+"+"+MDESC_FLD,MFLD_TITLE,03,45,mbott_row,76)

      MVALID = !EMPTY(MDESC)
      
      IF MVALID
         MFLD_VAL = LEFT(MDESC,MCODE_LEN)
         MDESC = RIGHT(MDESC,LEN(MDESC)-MCODE_LEN)
         @ MGET_ROW,MGET_COL GET MFLD_VAL
         CLEAR GETS
         IF MDISP_DESC
            *IF !EMPTY(MWONTOP)
            *   ACTIVATE WINDOW &MWONTOP
            *ENDIF
            @ MGET_ROW,MGET_COL+MCODE_LEN+1 SAY MDESC
         ELSE
            @ 24,00 SAY PADR(MFLD_TITLE + ": " + MDESC,80)
         ENDIF   
      ELSE
         IF !MOPTIONAL
            ACTIVATE WINDOW VCODEMSG
            ?? CHR(07) + MFLD_TITLE + " code must be entered or selected."
            K = INKEY(0)
            DEACTIVATE WINDOW VCODEMSG
            MVALID = .F.
         ENDIF
      ENDIF
      
   CASE !EMPTY(MFLD_VAL)
      * something entered
      
      SELECT (MTBL)
      SEEK MFLD_VAL
      MVALID = FOUND()

      IF MVALID
         IF MDISP_DESC
            *IF !EMPTY(MWONTOP)
            *   ACTIVATE WINDOW &MWONTOP
            *ENDIF
            @ MGET_ROW,MGET_COL+MCODE_LEN+1 SAY &MDESC_FLD
         ELSE
            *****@ 24,00 SAY PADR(MFLD_TITLE + ": " + DESC,80)
         ENDIF   
      ELSE
         ACTIVATE WINDOW VCODEMSG
         ?? CHR(07) + MFLD_TITLE + " code not found in table!"
         K = INKEY(0)
         DEACTIVATE WINDOW VCODEMSG
         MVALID = .F.
      ENDIF

   OTHERWISE

      IF !MOPTIONAL
         ACTIVATE WINDOW VCODEMSG
         ?? CHR(07) + MFLD_TITLE + " code cannot be blank."
         K = INKEY(0)
         DEACTIVATE WINDOW VCODEMSG
         MVALID = .F.
      ENDIF

ENDCASE

SELECT (MTBL)
USE
SELECT (MAREA)

*IF !EMPTY(MWONTOP)
*   ACTIVATE WINDOW &MWONTOP
*ENDIF

RELEASE WINDOW VCODEMSG

RETURN MVALID

